package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.DataEntity;

/**
 * 实体[CodeList] 数据对象
 */
@TableName(value = "T_SRFCODELIST",resultMap = "CodeListResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class CodeList extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private DataEntity de;
    private String clmodel;
    private String clparam;
    private String clpath;
    private Integer clversion;
    @TableId(value= "codelistid",type=IdType.UUID)//指定主键生成策略
    private String codelistid;
    private String codelistname;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String deid;
    @TableField(exist = false)//逻辑属性
    private String dename;
    private String emptytext;
    private String filler;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer issystem;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer isuserscope;
    private String memo;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer novalueempty;
    @Dict(dictName = "ionicdemo_CodeList20CodeList")
    private String ormode;
    private String reserver;
    private String reserver2;
    private String reserver3;
    private String reserver4;
    private Timestamp reserver5;
    private String seperator;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer srfsyspub;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer srfuserpub;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String valueseperator;
    /**
     *  设置属性值[代码表模型]
     *  @param clmodel
     */
    public void setClmodel(String clmodel){
        if(StringUtils.isEmpty(clmodel))
            clmodel=null;
        this.clmodel = clmodel;
        this.set("clmodeldirtyflag",true);
    }
    /**
     *  获取属性值[代码表模型]
     */
    public String getClmodel(){
        return this.clmodel;
    }
    /**
     *  重置属性值[代码表模型]
     */
    public void resetClmodel(){
        this.set("clmodeldirtyflag",false);
        this.clmodel = null;
    }
    /**
     *  设置属性值[代码表参数]
     *  @param clparam
     */
    public void setClparam(String clparam){
        if(StringUtils.isEmpty(clparam))
            clparam=null;
        this.clparam = clparam;
        this.set("clparamdirtyflag",true);
    }
    /**
     *  获取属性值[代码表参数]
     */
    public String getClparam(){
        return this.clparam;
    }
    /**
     *  重置属性值[代码表参数]
     */
    public void resetClparam(){
        this.set("clparamdirtyflag",false);
        this.clparam = null;
    }
    /**
     *  设置属性值[配置路径]
     *  @param clpath
     */
    public void setClpath(String clpath){
        if(StringUtils.isEmpty(clpath))
            clpath=null;
        this.clpath = clpath;
        this.set("clpathdirtyflag",true);
    }
    /**
     *  获取属性值[配置路径]
     */
    public String getClpath(){
        return this.clpath;
    }
    /**
     *  重置属性值[配置路径]
     */
    public void resetClpath(){
        this.set("clpathdirtyflag",false);
        this.clpath = null;
    }
    /**
     *  设置属性值[代码表版本]
     *  @param clversion
     */
    public void setClversion(Integer clversion){
        this.clversion = clversion;
        this.set("clversiondirtyflag",true);
    }
    /**
     *  获取属性值[代码表版本]
     */
    public Integer getClversion(){
        return this.clversion;
    }
    /**
     *  重置属性值[代码表版本]
     */
    public void resetClversion(){
        this.set("clversiondirtyflag",false);
        this.clversion = null;
    }
    /**
     *  设置属性值[代码表标识]
     *  @param codelistid
     */
    public void setCodelistid(String codelistid){
        if(StringUtils.isEmpty(codelistid))
            codelistid=null;
        this.codelistid = codelistid;
        this.set("codelistiddirtyflag",true);
    }
    /**
     *  获取属性值[代码表标识]
     */
    public String getCodelistid(){
        return this.codelistid;
    }
    /**
     *  重置属性值[代码表标识]
     */
    public void resetCodelistid(){
        this.set("codelistiddirtyflag",false);
        this.codelistid = null;
    }
    /**
     *  设置属性值[代码表名称]
     *  @param codelistname
     */
    public void setCodelistname(String codelistname){
        if(StringUtils.isEmpty(codelistname))
            codelistname=null;
        this.codelistname = codelistname;
        this.set("codelistnamedirtyflag",true);
    }
    /**
     *  获取属性值[代码表名称]
     */
    public String getCodelistname(){
        return this.codelistname;
    }
    /**
     *  重置属性值[代码表名称]
     */
    public void resetCodelistname(){
        this.set("codelistnamedirtyflag",false);
        this.codelistname = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[数据实体]
     *  @param deid
     */
    public void setDeid(String deid){
        if(StringUtils.isEmpty(deid))
            deid=null;
        this.deid = deid;
        this.set("deiddirtyflag",true);
    }
    /**
     *  获取属性值[数据实体]
     */
    public String getDeid(){
        return this.deid;
    }
    /**
     *  重置属性值[数据实体]
     */
    public void resetDeid(){
        this.set("deiddirtyflag",false);
        this.deid = null;
    }
    /**
     *  设置属性值[数据实体]
     *  @param dename
     */
    public void setDename(String dename){
        if(StringUtils.isEmpty(dename))
            dename=null;
        this.dename = dename;
        this.set("denamedirtyflag",true);
    }
    /**
     *  获取属性值[数据实体]
     */
    public String getDename(){
        return this.dename;
    }
    /**
     *  重置属性值[数据实体]
     */
    public void resetDename(){
        this.set("denamedirtyflag",false);
        this.dename = null;
    }
    /**
     *  设置属性值[空白显示内容]
     *  @param emptytext
     */
    public void setEmptytext(String emptytext){
        if(StringUtils.isEmpty(emptytext))
            emptytext=null;
        this.emptytext = emptytext;
        this.set("emptytextdirtyflag",true);
    }
    /**
     *  获取属性值[空白显示内容]
     */
    public String getEmptytext(){
        return this.emptytext;
    }
    /**
     *  重置属性值[空白显示内容]
     */
    public void resetEmptytext(){
        this.set("emptytextdirtyflag",false);
        this.emptytext = null;
    }
    /**
     *  设置属性值[数据库填充器]
     *  @param filler
     */
    public void setFiller(String filler){
        if(StringUtils.isEmpty(filler))
            filler=null;
        this.filler = filler;
        this.set("fillerdirtyflag",true);
    }
    /**
     *  获取属性值[数据库填充器]
     */
    public String getFiller(){
        return this.filler;
    }
    /**
     *  重置属性值[数据库填充器]
     */
    public void resetFiller(){
        this.set("fillerdirtyflag",false);
        this.filler = null;
    }
    /**
     *  设置属性值[系统数据]
     *  @param issystem
     */
    public void setIssystem(Integer issystem){
        this.issystem = issystem;
        this.set("issystemdirtyflag",true);
    }
    /**
     *  获取属性值[系统数据]
     */
    public Integer getIssystem(){
        return this.issystem;
    }
    /**
     *  重置属性值[系统数据]
     */
    public void resetIssystem(){
        this.set("issystemdirtyflag",false);
        this.issystem = null;
    }
    /**
     *  设置属性值[用户范围]
     *  @param isuserscope
     */
    public void setIsuserscope(Integer isuserscope){
        this.isuserscope = isuserscope;
        this.set("isuserscopedirtyflag",true);
    }
    /**
     *  获取属性值[用户范围]
     */
    public Integer getIsuserscope(){
        return this.isuserscope;
    }
    /**
     *  重置属性值[用户范围]
     */
    public void resetIsuserscope(){
        this.set("isuserscopedirtyflag",false);
        this.isuserscope = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[无值显示空白]
     *  @param novalueempty
     */
    public void setNovalueempty(Integer novalueempty){
        this.novalueempty = novalueempty;
        this.set("novalueemptydirtyflag",true);
    }
    /**
     *  获取属性值[无值显示空白]
     */
    public Integer getNovalueempty(){
        return this.novalueempty;
    }
    /**
     *  重置属性值[无值显示空白]
     */
    public void resetNovalueempty(){
        this.set("novalueemptydirtyflag",false);
        this.novalueempty = null;
    }
    /**
     *  设置属性值[或模式]
     *  @param ormode
     */
    public void setOrmode(String ormode){
        if(StringUtils.isEmpty(ormode))
            ormode=null;
        this.ormode = ormode;
        this.set("ormodedirtyflag",true);
    }
    /**
     *  获取属性值[或模式]
     */
    public String getOrmode(){
        return this.ormode;
    }
    /**
     *  重置属性值[或模式]
     */
    public void resetOrmode(){
        this.set("ormodedirtyflag",false);
        this.ormode = null;
    }
    /**
     *  设置属性值[保留字段]
     *  @param reserver
     */
    public void setReserver(String reserver){
        if(StringUtils.isEmpty(reserver))
            reserver=null;
        this.reserver = reserver;
        this.set("reserverdirtyflag",true);
    }
    /**
     *  获取属性值[保留字段]
     */
    public String getReserver(){
        return this.reserver;
    }
    /**
     *  重置属性值[保留字段]
     */
    public void resetReserver(){
        this.set("reserverdirtyflag",false);
        this.reserver = null;
    }
    /**
     *  设置属性值[保留字段2]
     *  @param reserver2
     */
    public void setReserver2(String reserver2){
        if(StringUtils.isEmpty(reserver2))
            reserver2=null;
        this.reserver2 = reserver2;
        this.set("reserver2dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段2]
     */
    public String getReserver2(){
        return this.reserver2;
    }
    /**
     *  重置属性值[保留字段2]
     */
    public void resetReserver2(){
        this.set("reserver2dirtyflag",false);
        this.reserver2 = null;
    }
    /**
     *  设置属性值[保留字段3]
     *  @param reserver3
     */
    public void setReserver3(String reserver3){
        if(StringUtils.isEmpty(reserver3))
            reserver3=null;
        this.reserver3 = reserver3;
        this.set("reserver3dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段3]
     */
    public String getReserver3(){
        return this.reserver3;
    }
    /**
     *  重置属性值[保留字段3]
     */
    public void resetReserver3(){
        this.set("reserver3dirtyflag",false);
        this.reserver3 = null;
    }
    /**
     *  设置属性值[保留字段4]
     *  @param reserver4
     */
    public void setReserver4(String reserver4){
        if(StringUtils.isEmpty(reserver4))
            reserver4=null;
        this.reserver4 = reserver4;
        this.set("reserver4dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段4]
     */
    public String getReserver4(){
        return this.reserver4;
    }
    /**
     *  重置属性值[保留字段4]
     */
    public void resetReserver4(){
        this.set("reserver4dirtyflag",false);
        this.reserver4 = null;
    }
    /**
     *  设置属性值[保留字段5]
     *  @param reserver5
     */
    public void setReserver5(Timestamp reserver5){
        this.reserver5 = reserver5;
        this.set("reserver5dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段5]
     */
    public Timestamp getReserver5(){
        return this.reserver5;
    }
    /**
     *  重置属性值[保留字段5]
     */
    public void resetReserver5(){
        this.set("reserver5dirtyflag",false);
        this.reserver5 = null;
    }
    /**
     *  设置属性值[显示分割符号]
     *  @param seperator
     */
    public void setSeperator(String seperator){
        if(StringUtils.isEmpty(seperator))
            seperator=null;
        this.seperator = seperator;
        this.set("seperatordirtyflag",true);
    }
    /**
     *  获取属性值[显示分割符号]
     */
    public String getSeperator(){
        return this.seperator;
    }
    /**
     *  重置属性值[显示分割符号]
     */
    public void resetSeperator(){
        this.set("seperatordirtyflag",false);
        this.seperator = null;
    }
    /**
     *  设置属性值[框架发布]
     *  @param srfsyspub
     */
    public void setSrfsyspub(Integer srfsyspub){
        this.srfsyspub = srfsyspub;
        this.set("srfsyspubdirtyflag",true);
    }
    /**
     *  获取属性值[框架发布]
     */
    public Integer getSrfsyspub(){
        return this.srfsyspub;
    }
    /**
     *  重置属性值[框架发布]
     */
    public void resetSrfsyspub(){
        this.set("srfsyspubdirtyflag",false);
        this.srfsyspub = null;
    }
    /**
     *  设置属性值[应用发布]
     *  @param srfuserpub
     */
    public void setSrfuserpub(Integer srfuserpub){
        this.srfuserpub = srfuserpub;
        this.set("srfuserpubdirtyflag",true);
    }
    /**
     *  获取属性值[应用发布]
     */
    public Integer getSrfuserpub(){
        return this.srfuserpub;
    }
    /**
     *  重置属性值[应用发布]
     */
    public void resetSrfuserpub(){
        this.set("srfuserpubdirtyflag",false);
        this.srfuserpub = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[值分割符号]
     *  @param valueseperator
     */
    public void setValueseperator(String valueseperator){
        if(StringUtils.isEmpty(valueseperator))
            valueseperator=null;
        this.valueseperator = valueseperator;
        this.set("valueseperatordirtyflag",true);
    }
    /**
     *  获取属性值[值分割符号]
     */
    public String getValueseperator(){
        return this.valueseperator;
    }
    /**
     *  重置属性值[值分割符号]
     */
    public void resetValueseperator(){
        this.set("valueseperatordirtyflag",false);
        this.valueseperator = null;
    }
     /**
     *  获取主实体关联数据[DataEntity]
     */
    public DataEntity getDe() {
        return de;
    }
    /**
     *  设置主实体关联数据[DataEntity]
     */
    public void setDe(DataEntity de) {
        this.de = de;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetClmodel();
        resetClparam();
        resetClpath();
        resetClversion();
        resetCodelistid();
        resetCodelistname();
        resetCreatedate();
        resetCreateman();
        resetDeid();
        resetDename();
        resetEmptytext();
        resetFiller();
        resetIssystem();
        resetIsuserscope();
        resetMemo();
        resetNovalueempty();
        resetOrmode();
        resetReserver();
        resetReserver2();
        resetReserver3();
        resetReserver4();
        resetReserver5();
        resetSeperator();
        resetSrfsyspub();
        resetSrfuserpub();
        resetUpdatedate();
        resetUpdateman();
        resetValueseperator();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public CodeList copyTo(CodeList targetEntity)
	{
		BeanCopier copier=BeanCopier.create(CodeList.class, CodeList.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetCodelistid();
		return targetEntity;
	}
}